#!/usr/bin/ruby -Ku
=begin
255 までの数値を出力するプログラムに対して最適化

問題点:
  255 以上を扱う場合、短くする段階で無限ループになる bf にしてしまう。
=end

require "rubygems"
require "mathn"
# http://rubyforge.org/frs/?group_id=291
require "permutation.rb"

input = ARGF.read
COL = 50


def min_combination(int)
	case int.abs
	when 0
		return [0, 0, false]
	when 1
		return [1, 1, false]
	when 2
		return [1, 1, true]
	when 3
		return [2, 1, true]
	end
	
	ret = []
	prime = false
	
	l = int.prime_division.collect {|pr,po| [pr] * po }.flatten
	if l.length == 1
		prime = true
		l = (int-1).prime_division.collect {|pr,po| [pr] * po }.flatten
	end
	
	perm = Permutation.new(l.length).map {|p| p.project(l) }
	perm.uniq!
	perm.slice!(perm.length / 2, perm.length / 2)
	perm.each do |i|
		(1..(l.length-1)).each do |t|
			ret << [i[t, i.length], i[0, t]]
		#	j = 0
		#	ret << i.partition {|_| j += 1; j > t}
		end
	end
	ret.collect! do |a,b|
		[a.inject {|r,i| r*i}, b.inject {|r,i| r*i}]
	end
	ret = ret.min { |a,b|
		(a[0] + a[1]) <=> (b[0] + b[1])
	}
	ret << prime
end
#p min_combination(4)
#p min_combination(-4)
#p min_combination(0)
#p min_combination(-2)
#p min_combination(-3)


ret = ""

prev = 0
input.each_byte do |c|
	#c = c.unpack("U")[0]
	t = c - prev
	if t > 0
		ret << "+" * t
	else
		ret << "-" * t.abs
	end
	prev = c
	ret << "."
end

$CACHE = {}

# shorten
i = 1
while ret.gsub!(/([+-]){#{15+i*4},}/) { |m|
	a, b, prime = $CACHE[m.length] ? $CACHE[m.length] : ($CACHE[m.length] = min_combination(m.length))
	
	#p [a, b, prime]
	r = ""
	r << ">" * i
	r << "+" * a
	r << "[-"
	r << "<" * i
	r << $1 * b
	r << ">" * i
	r << "]"
	r << "<" * i
	r << $1 if prime
	r
}
#puts ret
#puts
#i += 1
end
ret.gsub!(/<>|></, "")



i = 0
while ret.length > i
	puts ret[i, COL]
	i += COL
end
